# mikemth.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das tcl  liest  die www.mikemth.de  news aus  und gibt sie wieder, gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
#
# v1.0 - erste public version
#
# miketrigger - der trigger auf den der bot reagiert (public und message)
# mikelimit - maximum der news die auf befehl geposted werden
# mikenewspost  - 1 fr newsposting, 0 fr keines
# mikechans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# mikenewspostlimit - maximum der news die geposted werden
# ismikehub  - legt fest ob der bot newshub ist oder nicht
# mikeleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set miketrigger ".mikemth"
set mikechans ""
set mikelimit "5"
set mikenewspostlimit "3"
set mikenewspost "1"
set ismikehub "0"
set mikeleafs ""

####### ende der config #############

bind msg - $miketrigger msg_mike
bind pub - $miketrigger pub_mike
bind time - "?0 * * * *" mikecheck

proc sendmikenews { arg } {
global mikeleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $mikeleafs] [string tolower $bot]] != -1)} {
putbot $bot "mike: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc mikenews { target limit } {
if {[catch {set sock [socket mikemth.de 1337] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /search.php?min=0&type=stories&category= HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: mikemth.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<a href=\"article.php" $bl] != -1} {
set link "http://mikemth.de:1337/[string range $bl [shrink + 7 " href=\"" 0 $bl] [shrink - 1 "\"><b>" 0 $bl]]"
set newsline [string range $bl [shrink + 5 "\"><b>" 0 $bl] [shrink - 1 "</b></a>" 0 $bl]]
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc mikecheck {nick uhost hand chan arg} {
global mikechans mikenewspost ismikehub mikenewspostlimit
set counter 0
if {$mikenewspost == 1 } {
putlog "mike: suche nach neuer newsline"
set mikelastnews "none"
if {[file exists mike.hdl]} {
set temp [open "mike.hdl" r]
set mikelastnews "[gets $temp]"
if {$mikelastnews == ""} { set mikelastnews "none" }
close $temp
}
set temp [open "mike.hdl" w+]
if {[catch {set sock [socket mikemth.de 1337] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /search.php?min=0&type=stories&category= HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: mikemth.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<a href=\"article.php" $bl] != -1} {
set link "http://mikemth.de:1337/[string range $bl [shrink + 7 " href=\"" 0 $bl] [shrink - 1 "\"><b>" 0 $bl]]"
set newsline [string range $bl [shrink + 5 "\"><b>" 0 $bl] [shrink - 1 "</b></a>" 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$mikelastnews == "none" } { putlog "mike: headlinefile created" ; return 0 }
set temp [open "mike.hdl" r]
while { [eof $temp] != 1 } {
set mikeneunews [gets $temp]
if {($mikelastnews == $mikeneunews) || ($counter == $mikenewspostlimit)} { close $temp;return 0 }
if { $ismikehub == "1" } { sendmikenews $mikeneunews }
incr counter
foreach chan [channels] {
if {$mikechans == "" } { putserv "privmsg $chan :(neue mikemth.de newsline) $mikeneunews" }
if {$mikechans != "" } {
if {([lsearch -exact [string tolower $mikechans] [string tolower $chan]] != -1) || ($mikechans == "")} {putserv "privmsg $chan :(neue mikemth.de newsline) $mikeneunews"}
}
}}}}


proc msg_mike { nick uhost hand arg } { global mikelimit ; mikenews $nick $mikelimit }
proc pub_mike { nick uhost hand chan arg } { global mikechans mikelimit ; if {([lsearch -exact [string tolower $mikechans] [string tolower $chan]] != -1) || ($mikechans == "")} { mikenews $nick $mikelimit }}


putlog "*** mikemth.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
